SystemOrganization addCategory: #'Smallchange-Test-Web'!
SystemOrganization addCategory: #'Smallchange-Test-Core'!
SystemOrganization addCategory: #'Smallchange-Test-Core-Commands'!

TestCase subclass: #TestScAccount
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 16:03'!
newAccount
	^profile newAccount! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/17/2012 20:24'!
setUp
	profile := ScBasicProfile new! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 21:01'!
testAccountIsAccount
	self assert: self newAccount isAccount! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 21:01'!
testAccountIsNotPool
	self deny: self newAccount isPool! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 19:42'!
testAddingTransactionIncreasesBalance
	| a |
	a := profile addAccount: self newAccount.
	profile addTransaction: (profile newIncome account: a; amount: 10; yourself).
	self assert: a balance equals: 10.
	! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:13'!
testAllocationIsNotIncoming
	| account pool |
	account := profile addAccount: profile newAccount.
	pool := profile addPool: profile newPool.
	self deny: (account isIncoming: (profile newTransaction sourceAccount: account; account: account; pool: pool; amount: 1; yourself))! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:13'!
testAllocationIsNotOutgoing
	| account pool |
	account := profile addAccount: self newAccount.
	pool := profile addPool: profile newPool.
	self deny: (account isOutgoing: (profile newTransaction sourceAccount: account; account: account; pool: pool; amount: 1; yourself))! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 19:45'!
testChangingOpeningBalanceUpdatesBalance
	| a |
	a := self newAccount.
	a openingBalance: 10.
	self assert: a balance equals: 10! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:15'!
testExpenseIsNotIncoming
	| account |
	account := profile addAccount: self newAccount.
	self deny: (account isIncoming: (profile newExpense sourceAccount: account; amount: 1; yourself))! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:15'!
testExpenseIsOutgoing
	| account |
	account := profile addAccount: self newAccount.
	self assert: (account isOutgoing: (profile newExpense sourceAccount: account; amount: 1; yourself))! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 20:52'!
testExpenseScheduleIsNotIncoming
	| account s1|
	account := profile addAccount: self newAccount.
	s1 := profile addSchedule: (profile newSchedule
		transaction: (profile newExpense sourceAccount: account; amount: 1; yourself);
		yourself).
	self deny: (account incomingSchedules includes: s1)! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 20:54'!
testExpenseScheduleIsOutgoing
	| account s1|
	account := profile addAccount: self newAccount.
	s1 := profile addSchedule: (profile newSchedule
		transaction: (profile newExpense sourceAccount: account; amount: 1; yourself);
		yourself).
	self assert: (account outgoingSchedules includes: s1)! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:14'!
testIncomeIsIncoming
	| account |
	account := profile addAccount: self newAccount.
	self assert: (account isIncoming: (profile newIncome account: account; amount: 1; yourself))! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:14'!
testIncomeIsNotOutgoing
	| account |
	account := profile addAccount: self newAccount.
	self deny: (account isOutgoing: (profile newIncome account: account; amount: 1; yourself))! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 20:51'!
testIncomeScheduleIsIncoming
	| account s1|
	account := profile addAccount: self newAccount.
	s1 := profile addSchedule: (profile newSchedule
		transaction: (profile newIncome account: account; amount: 1; yourself);
		yourself).
	self assert: (account incomingSchedules includes: s1)! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 20:54'!
testIncomeScheduleIsNotOutgoing
	| account s1|
	account := profile addAccount: self newAccount.
	s1 := profile addSchedule: (profile newSchedule
		transaction: (profile newIncome account: account; amount: 1; yourself);
		yourself).
	self deny: (account outgoingSchedules includes: s1)! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 19:43'!
testModifyingTransactionChangesBalance
	| a t |
	a := profile addAccount: self newAccount.
	t := profile addTransaction: (profile newIncome account: a; amount: 10; yourself).
	t amount: 15.
	self assert: a balance equals: 15.
	! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 19:43'!
testRemovingTransactionDecreasesBalance
	| a t |
	a := profile addAccount: self newAccount.
	t := profile addTransaction: (profile newIncome account: a; amount: 10; yourself).
	profile removeTransaction: t.
	self assert: a balance equals: 0.
	! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:18'!
testScheduldTransferOutIsOutgoing
	| account s1 account2 |
	account := profile addAccount: self newAccount.
	account2 := profile addAccount: (self newAccount name: 'a2'; yourself).
	s1 := profile addSchedule: (profile newSchedule
		transaction: (profile newTransaction account: account2; sourceAccount: account; amount: 1; yourself);
		yourself).
	self assert: (account outgoingSchedules includes: s1)! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:13'!
testScheduledAllocationIsNotIncoming
	| account s1 pool |
	account := profile addAccount: profile newAccount.
	pool := profile addPool: profile newPool.
	s1 := profile addSchedule: (profile newSchedule
		transaction: (profile newTransaction sourceAccount: account; account: account; pool: pool; amount: 1; yourself);
		yourself).
	self deny: (account incomingSchedules includes: s1)! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:13'!
testScheduledAllocationIsNotOutgoing
	| account s1 pool |
	account := profile addAccount: self newAccount.
	pool := profile addPool: profile newPool.
	s1 := profile addSchedule: (profile newSchedule
		transaction: (profile newTransaction sourceAccount: account; account: account; pool: pool; amount: 1; yourself);
		yourself).
	self deny: (account outgoingSchedules includes: s1)! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:08'!
testScheduledTransferInIsIncoming
	| account s1 account2 |
	account := profile addAccount: self newAccount.
	account2 := profile addAccount: (self newAccount name: 'a2'; yourself).
	s1 := profile addSchedule: (profile newSchedule
		transaction: (profile newTransaction sourceAccount: account2; account: account; amount: 1; yourself);
		yourself).
	self assert: (account incomingSchedules includes: s1)! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:18'!
testScheduledTransferInIsNotOutgoing
	| account s1 account2 |
	account := profile addAccount: self newAccount.
	account2 := profile addAccount: (self newAccount name: 'a2'; yourself).
	s1 := profile addSchedule: (profile newSchedule
		transaction: (profile newTransaction sourceAccount: account2; account: account; amount: 1; yourself);
		yourself).
	self deny: (account outgoingSchedules includes: s1)! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:10'!
testScheduledTransferOutIsNotIncoming
	| account s1 account2 |
	account := profile addAccount: self newAccount.
	account2 := profile addAccount: (self newAccount name: 'a2'; yourself).
	s1 := profile addSchedule: (profile newSchedule
		transaction: (profile newTransaction account: account2; sourceAccount: account; amount: 1; yourself);
		yourself).
	self deny: (account incomingSchedules includes: s1)! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:18'!
testScheduledTransferOutIsOutgoing
	| account s1 account2 |
	account := profile addAccount: self newAccount.
	account2 := profile addAccount: (self newAccount name: 'a2'; yourself).
	s1 := profile addSchedule: (profile newSchedule
		transaction: (profile newTransaction account: account2; sourceAccount: account; amount: 1; yourself);
		yourself).
	self assert: (account outgoingSchedules includes: s1)! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 19:31'!
testStartingBalanceIsZero
	self assert: profile newAccount balance equals: 0! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 19:31'!
testStartingOpeningBalanceIsZero
	self assert: profile newAccount openingBalance equals: 0! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 16:04'!
testTransactionWithAccountSetAppearsinAccountsTransactionList
	| account t |
	account := self newAccount.
	profile addAccount: account.
	t := profile newTransaction
			account: account.
	profile addTransaction: t.
	account transactions should include: t.! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:10'!
testTransferInIsIncoming
	| account account2 |
	account := profile addAccount: self newAccount.
	account2 := profile addAccount: (self newAccount name: 'a2'; yourself).
	self assert: (account isIncoming: ( profile newTransaction sourceAccount: account2; account: account; amount: 1; yourself))! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:10'!
testTransferInIsNotOutgoing
	| account account2 |
	account := profile addAccount: self newAccount.
	account2 := profile addAccount: (self newAccount name: 'a2'; yourself).
	self deny: (account isOutgoing: ( profile newTransaction sourceAccount: account2; account: account; amount: 1; yourself))! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:11'!
testTransferOutIsNotIncoming
	| account  account2 |
	account := profile addAccount: self newAccount.
	account2 := profile addAccount: (self newAccount name: 'a2'; yourself).
	self deny: (account isIncoming: (profile newTransaction account: account2; sourceAccount: account; amount: 1; yourself))! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:16'!
testTransferOutIsOutgoing
	| account s1 account2 |
	account := profile addAccount: self newAccount.
	account2 := profile addAccount: (self newAccount name: 'a2'; yourself).
	self assert: (account isOutgoing: (profile newTransaction account: account2; sourceAccount: account; amount: 1; yourself))! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 22:02'!
testTransferringTransactionChangesBalance
	| a a2 t |
	a := profile addAccount: self newAccount.
	a2 := profile addAccount: (self newAccount name: 'a2'; yourself).
	t := profile addTransaction: (profile newIncome account: a; amount: 10; yourself).
	t account: a2.
	self assert: a balance equals: 0.
	! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 21:15'!
testUnrelatedScheduleIsNotIncoming
	| account s1 account2 |
	account := profile addAccount: self newAccount.
	account2 := profile addAccount: (self newAccount name: 'a2'; yourself).
	s1 := profile addSchedule: (profile newSchedule
		transaction: (profile newIncome account: account2; amount: 1; yourself);
		yourself).
	self deny: (account incomingSchedules includes: s1)! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:12'!
testUnrelatedScheduleIsNotOutgoing
	| account s1 account2 |
	account := profile addAccount: self newAccount.
	account2 := profile addAccount: (self newAccount name: 'a2'; yourself).
	self deny: (account isOutgoing: (profile newExpense sourceAccount: account2; amount: 1; yourself))! !

!TestScAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 22:12'!
testUnrelatedTransactionIsNotIncoming
	| account s1 account2 |
	account := profile addAccount: self newAccount.
	account2 := profile addAccount: (self newAccount name: 'a2'; yourself).
	self deny: (account isIncoming: (profile newIncome account: account2; amount: 1; yourself))! !

TestCase subclass: #TestScAccountCalculations
	instanceVariableNames: 'account profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScAccountCalculations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/7/2012 21:53'!
addTransactionOfAmount: anAmount on: date
	profile addTransaction: (profile newExpense 
		sourceAccount: account;
		amount: anAmount;
		date: date).
! !

!TestScAccountCalculations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/17/2012 20:24'!
setUp
	profile := ScBasicProfile new.
	account := profile newAccount
		openingBalance: 0;
		yourself.
	profile addAccount: account.! !

!TestScAccountCalculations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/7/2012 21:59'!
testAverageSpend
	self addTransactionOfAmount: 10 on: Date today.
	self addTransactionOfAmount: 1 on: Date today - 7 days.
	self assert: (account averageSpendPer: ScDaily) equals: 11/8! !

!TestScAccountCalculations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/7/2012 21:39'!
testAverageSpendWhenNoTransactions
	self assert: (account averageSpendPer: Week) equals: 0.! !

!TestScAccountCalculations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/7/2012 22:00'!
testAverageSpendWhenOneTransaction
	"If  existing transactions are less than the time period then their sum is the average - don't extrapolate"
	self addTransactionOfAmount: 10 on: Date today.
	self assert: (account averageSpendPer: ScWeekly) equals: 10.! !

!TestScAccountCalculations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 19:27'!
testExpectedBalanceByAnswersBalanceWhenNoTransactionMatch
	[:p :transaction |	
		account := ScAccount profile: p.
		[ self assert: (account expectedBalanceBy: Date tomorrow) equals: 0]
			should lenient satisfy: [
				(p expectedTransactionsBy: Date tomorrow) willReturn: {transaction}.
				transaction sourceAccount willReturn: nil.
				transaction account willReturn: nil.
			]] runScenario! !

!TestScAccountCalculations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/8/2012 18:13'!
testExpectedBalanceByAnswersBalanceWhenNoTransactions
	account openingBalance: 10.
	self assert: (account expectedBalanceBy: Date tomorrow) equals: 10.! !

!TestScAccountCalculations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 19:27'!
testExpectedBalanceByWithIncomeAndExpense
	[:p |	 account := ScAccount profile: p.
		[ self assert: (account expectedBalanceBy: Date tomorrow) equals: 7]
			should lenient satisfy: [
				(p expectedTransactionsBy: Date tomorrow) willReturn: {
					(ScExpense profile: p)
						instVarNamed: #sourceAccount put: account;
						amount: 3.
					(ScIncome profile: p)
						instVarNamed: #account put: account;
						amount: 10}.
			]] runScenario! !

!TestScAccountCalculations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 19:27'!
testExpectedBalanceByWithOneExpense
	[:p |	 account := ScAccount profile: p.
		[ self assert: (account expectedBalanceBy: Date tomorrow) equals: -10]
			should lenient satisfy: [
				(p expectedTransactionsBy: Date tomorrow) willReturn: {
					(ScExpense profile: p)
						instVarNamed: #sourceAccount put: account;
						amount: 10}.
			]] runScenario! !

!TestScAccountCalculations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 19:27'!
testExpectedBalanceByWithOneIncome
	[:p |	 account := ScAccount profile: p.
		[ self assert: (account expectedBalanceBy: Date tomorrow) equals: 10]
			should lenient satisfy: [
				(p expectedTransactionsBy: Date tomorrow) willReturn: {
					(ScIncome profile: p)
						instVarNamed: #account put: account;
						amount: 10}.
			]] runScenario! !

TestCase subclass: #TestScAccountNotOverdrawn
	instanceVariableNames: 'profile overdrawnAccount zeroBalanceAccount positiveAccount analyser'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScAccountNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/25/2012 21:27'!
setUp
	profile := ScBasicProfile new.
	overdrawnAccount := profile newAccount name: 'Overdrawn Account'; openingBalance: -1; yourself.
	zeroBalanceAccount := profile newAccount name: 'ZeroBalance Account'; openingBalance: 0;yourself.
	positiveAccount := profile newAccount name: 'Positive Account'; openingBalance: 1;yourself.
	
	profile addAccount: overdrawnAccount.
	profile addAccount: zeroBalanceAccount.	
	profile addAccount: positiveAccount.

	analyser := ScAccountsNotOverdrawn profile: profile.
	analyser modificationAnnouncer: (profile instVarNamed: #announcer).
	analyser notices. "force a run of the analyser"! !

!TestScAccountNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/4/2012 21:39'!
testAcceptingPendingTransactionsRaisesNotice
	(profile instVarNamed: #pendingTransactions) 
		add: (ScScheduledTransaction schedule: (profile addSchedule: (profile newSchedule name: 's'; yourself)) transaction: (profile newExpense sourceAccount: zeroBalanceAccount; amount: 1)).
	(ScAcceptTransactions profile: profile transactions: (profile pendingTransactions)) do.
	self assert: (analyser notices anySatisfy: [ :n | n account = zeroBalanceAccount ])! !

!TestScAccountNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 19:04'!
testAccountWithNearZeroBalanceNotOverdrawn
	zeroBalanceAccount openingBalance: ((Fraction numerator: -3 denominator: 1759218604441600) asScaledDecimal: 2).
	self deny: (analyser notices anySatisfy: [ :n | n account = zeroBalanceAccount ])! !

!TestScAccountNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/25/2012 21:48'!
testAddingExpenseRaisesNotice
	profile addTransaction: (profile newExpense
		sourceAccount: positiveAccount;
		amount: 2;
		yourself).
	self assert: (analyser notices anySatisfy: [ :n | n account = positiveAccount ])! !

!TestScAccountNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/12/2012 19:34'!
testAddingIncomeRemovesNotice
	profile addTransaction: (profile newIncome
		account: overdrawnAccount;
		amount: 2;
		yourself).
	self deny: (analyser notices anySatisfy: [ :n | n account = overdrawnAccount ])! !

!TestScAccountNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 21:13'!
testModifyingAccountRaisesNotice
	zeroBalanceAccount openingBalance: -1.
	self assert: (analyser notices anySatisfy: [ :n | n account = zeroBalanceAccount ])! !

!TestScAccountNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/12/2012 19:36'!
testModifyingAccountRemovesNotice
	overdrawnAccount openingBalance: 1.
	self deny: (analyser notices anySatisfy: [ :n | n account = overdrawnAccount ])! !

!TestScAccountNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/12/2012 19:32'!
testModifyingTransactionRaisesNotice
	| t|
	t := profile newExpense
		sourceAccount: positiveAccount;
		amount: 1;
		yourself.
	profile addTransaction: t.
	t amount: 2.
	self assert: (analyser notices anySatisfy: [ :n | n account = positiveAccount ])! !

!TestScAccountNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/12/2012 19:33'!
testModifyingTransactionRemovesNotice
	| t|
	t := profile newExpense
		sourceAccount: positiveAccount;
		amount: 2;
		yourself.
	profile addTransaction: t.
	t amount: 1.
	self deny: (analyser notices anySatisfy: [ :n | n account = positiveAccount ])! !

!TestScAccountNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/9/2012 20:25'!
testOnlyOneAccountRaisesANotice
	self assert: analyser notices size equals: 1! !

!TestScAccountNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/9/2012 20:26'!
testOverdrawnAccountShouldRaiseNotice
	self assert: (analyser notices anySatisfy: [ :n | n account = overdrawnAccount ])! !

!TestScAccountNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/4/2012 21:24'!
testPendingTransactionsDontRaiseNotice
	(profile instVarNamed: #pendingTransactions) 
		add: (ScScheduledTransaction schedule: (profile addSchedule: (profile newSchedule name: 's'; yourself)) transaction: (profile newExpense account: zeroBalanceAccount; amount: 1)).
	self deny: (analyser notices anySatisfy: [ :n | n account = zeroBalanceAccount ])! !

!TestScAccountNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/9/2012 20:25'!
testPositiveAccountShouldntRaiseNotice
	self deny: (analyser notices anySatisfy: [ :n | n account = positiveAccount ])! !

!TestScAccountNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/12/2012 19:34'!
testRemovingExpenseRemovesNotice
	| t | 
	t := (profile newExpense
		sourceAccount: positiveAccount;
		amount: 2;
		yourself).
	profile addTransaction: t.
	profile removeTransaction: t.
	self deny: (analyser notices anySatisfy: [ :n | n account = positiveAccount ])! !

!TestScAccountNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/12/2012 19:35'!
testRemovingIncomeRaisesNotice
	| t | 
	t := (profile newIncome
		account: overdrawnAccount;
		amount: 2;
		yourself).
	profile addTransaction: t.
	profile removeTransaction: t.
	self assert: (analyser notices anySatisfy: [ :n | n account = overdrawnAccount ])! !

!TestScAccountNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 5/9/2012 20:25'!
testZeroBalanceAccountShouldntRaiseNotice
	self deny: (analyser notices anySatisfy: [ :n | n account = zeroBalanceAccount ])! !

TestCase subclass: #TestScAccountsSufficientForBills
	instanceVariableNames: 'profile account analyser account2 income'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/15/2012 18:07'!
expenseFor: anAmount
	^(ScExpense profile: profile) sourceAccount: account; amount: anAmount! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:32'!
setUp
	profile := ScBasicProfile new.
	"This should prevent Unallocated from causing additional warnings"		
	profile addAccount: (profile newAccount name: 'Unlimited funds!!'; openingBalance: 1000000; yourself). 

	account := profile addAccount: 
		(profile newAccount name: 'My Account'; openingBalance: 0; yourself).
	account2 := profile addAccount: 
		(profile newAccount name: 'Account 2'; openingBalance: 0;yourself).
	
	income := profile addSchedule: 
		((profile newSchedule 
			name: 'Pay Day'; 
			interval: #month; 
			count: 1; 
			start: (Date today addDays: 10); 
			transaction: (profile newIncome account:  account; amount: 100; yourself))).
			
	analyser := (ScAccountsSufficientForBills profile: profile)
		modificationAnnouncer: (profile instVarNamed: #announcer);
		yourself.! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 21:41'!
testAddingScheduleUpdatesNotices
	self assert: analyser notices size equals: 0.
	profile addSchedule: (profile newSchedule start: (Date tomorrow addDays: 11); interval: #month; count: 1; 
		transaction: (self expenseFor: 200)).
	self assert: analyser notices size equals: 1! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 19:42'!
testBillAfterInsufficientPayday
	profile addSchedule: (profile newSchedule start: (Date tomorrow addDays: 11); interval: #month; count: 1; 
		transaction: (self expenseFor: 200)).
	self assert: analyser notices size equals: 1! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 19:42'!
testBillAfterSufficientPayday
	profile addSchedule: (profile newSchedule start: (Date tomorrow addDays: 11); interval: #month; count: 1; 
		transaction: (self expenseFor: 100)).
	self assert: analyser notices isEmpty! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 19:42'!
testBillAfterSufficientPaydayWithAutomaticTransfer
	profile addSchedule: ((profile newSchedule name: 'bill'; start: (Date tomorrow addDays: 11); interval: #month; count: 1; 
		transaction: ((self expenseFor: 100) sourceAccount: account2)) coveredBy: income).
	self assert: analyser notices isEmpty! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 18:56'!
testBillBeforePayday
	profile addSchedule: (profile newSchedule start: (Date tomorrow); interval: #month; count: 1; 
		transaction: (self expenseFor: 200)).
	self assert: analyser notices notEmpty! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:27'!
testCantPayEitherBill
	profile addSchedule: (profile newSchedule name: 's1'; start: (Date tomorrow addDays: 11); interval: #month; count: 1; 
		transaction: (self expenseFor: 200)).
	profile addSchedule: (profile newSchedule name: 's2'; start: (Date tomorrow addDays: 12); interval: #month; count: 1; 
		transaction: (self expenseFor: 200)).
	self assert: analyser notices size equals: 2! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 19:42'!
testCantPaySecondBill
	profile addSchedule: (profile newSchedule name: 's1'; start: (Date tomorrow addDays: 11); interval: #month; count: 1; 
		transaction: (self expenseFor: 100)).
	profile addSchedule: (profile newSchedule name: 's2'; start: (Date tomorrow addDays: 12); interval: #month; count: 1; 
		transaction: (self expenseFor: 100)).
	self assert: analyser notices size equals: 1! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/29/2012 13:21'!
testDeletePendingTransactionUpdatesNotices
	| t| 
	t := (profile instVarNamed: #pendingTransactions) add: (ScScheduledTransaction schedule: (profile addSchedule: (profile newSchedule name: 's'; yourself)) transaction: (self expenseFor: 100)).
	profile addSchedule: (profile newSchedule start: (Date tomorrow addDays: 11); interval: #month; count: 1; 
		transaction: (self expenseFor: 100)).
	analyser notices.
	profile removePendingTransactions: {t}. 
	self assert: analyser notices isEmpty! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 22:23'!
testModifyingAccountUpdatesNotices
	profile addSchedule: (profile newSchedule start: (Date tomorrow addDays: 11); interval: #month; count: 1; 
		transaction: (self expenseFor: 100)).
	analyser notices.
	account openingBalance: -100.
	self deny: analyser notices isEmpty! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 22:23'!
testModifyingScheduleRaisesNotice
	| s |
	s := profile addSchedule: (profile newSchedule start: (Date tomorrow addDays: 11); interval: #month; count: 1; 
		transaction: (self expenseFor: 100)).
	analyser notices.
	s transaction: (self expenseFor: 110).
	self deny: analyser notices isEmpty! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 19:42'!
testNoBillsMeansNoWarnings
	self assert: analyser notices isEmpty! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/29/2012 12:53'!
testPendingTransactionCountsTowardsWarning
	(profile instVarNamed: #pendingTransactions) add: (ScScheduledTransaction schedule: (profile addSchedule: (profile newSchedule name: 's'; yourself)) transaction: (self expenseFor: 100)).
	profile addSchedule: (profile newSchedule start: (Date tomorrow addDays: 11); interval: #month; count: 1; 
		transaction: (self expenseFor: 100)).
	self assert: analyser notices notEmpty! !

!TestScAccountsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 21:42'!
testRemovingScheduleUpdatesNotices
	| s |
	s := profile addSchedule: (profile newSchedule start: (Date tomorrow addDays: 11); interval: #month; count: 1; 
		transaction: (self expenseFor: 200)).
	analyser notices.
	profile removeSchedule: s.
	self assert: analyser notices size equals: 0.
		
! !

TestScAccountsSufficientForBills subclass: #TestScPoolsSufficientForBills
	instanceVariableNames: 'pool pool2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScPoolsSufficientForBills class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 19:07'!
shouldInheritSelectors
	^true! !

!TestScPoolsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/15/2012 18:06'!
expenseFor: anAmount
	^(ScExpense profile: profile) sourceAccount: account; sourcePool: pool; amount: anAmount! !

!TestScPoolsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 19:12'!
setUp
	profile := ScBasicProfile new.
	"Prime the account, since we're not testing account notifications"
	account := profile newAccount name: 'My Account'; openingBalance: 100000; yourself.
	profile addAccount: account.
	pool := profile newPool name: 'A Pool'; defaultAccount: account;yourself.
	pool2 := profile newPool name: 'Pool 2'; defaultAccount: account;yourself.
	profile addPool: pool.
	profile addPool: pool2.
	income := (profile newSchedule name: 'Pay Day'; interval: #month; count: 1; start: (Date today addDays: 10); 
		transaction: ((ScIncome profile: profile) pool: pool; account: account; amount: 100)).
	profile addSchedule: income.
	analyser := (ScAccountsSufficientForBills profile: profile)
		modificationAnnouncer: (profile instVarNamed: #announcer);
		yourself.! !

!TestScPoolsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 19:42'!
testBillAfterSufficientPaydayWithAutomaticTransfer
	profile addSchedule: ((profile newSchedule name: 'A Bill'; start: (Date tomorrow addDays: 11); interval: #month; count: 1; 
		transaction: ((self expenseFor: 100) sourcePool: pool2)) coveredBy: income).
	self assert: analyser notices isEmpty! !

!TestScPoolsSufficientForBills methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 22:36'!
testModifyingAccountUpdatesNotices
	"N/A"! !

TestCase subclass: #TestScAddAccount
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core-Commands'!

!TestScAddAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:25'!
testAddAccountAddsToProfile
	[ :profile :account | [ (ScAddAccount profile: profile account: account) do ] 
		should strictly satisfy: [ profile addAccount: account ]] runScenario
! !

!TestScAddAccount methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:25'!
testUndoAddAccountRemovesFromProfile
	[ :profile :account |  |  command | 
		command := (ScAddAccount profile: profile account: account).
		[ command undo] 
			should strictly satisfy: [ profile removeAccount: account ]] runScenario! !

TestCase subclass: #TestScAddManualTransaction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core-Commands'!

!TestScAddManualTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/24/2012 18:08'!
testAddTransactionAddsToSchedule
	[ :schedule :transaction | [ (ScAddManualTransaction new schedule: schedule; transaction: transaction) do ] 
		should strictly satisfy: [ schedule addTransaction: transaction ]] runScenario
! !

!TestScAddManualTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/24/2012 18:13'!
testUndoAddTransactionRemovesFromSchedule
	[ :schedule :transaction |  |  command | 
		command := (ScAddManualTransaction new schedule: schedule; transaction: transaction).
		[ command undo] 
			should strictly satisfy: [ schedule removeTransaction: transaction ]] runScenario! !

TestCase subclass: #TestScAddPool
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core-Commands'!

!TestScAddPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:18'!
testAddPoolAddsToProfile
	[ :profile :pool | [ (ScAddPool profile: profile pool: pool) do ] 
		should strictly satisfy: [ profile addPool: pool ]] runScenario
! !

!TestScAddPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 20:19'!
testUndoAddPoolRemovesFromProfile
	[ :profile :pool |  |  command | 
		command := (ScAddPool profile: profile pool: pool).
		[ command undo] 
			should strictly satisfy: [ profile removePool: pool ]] runScenario! !

TestCase subclass: #TestScAddSchedule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core-Commands'!

!TestScAddSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 17:17'!
testAddScheduleAddsToProfile
	[ :profile :schedule | [ (ScAddSchedule profile: profile schedule: schedule) do ] 
		should strictly satisfy: [ profile addSchedule: schedule ]] runScenario
! !

!TestScAddSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 17:13'!
testUndoAddScheduleRemovesFromProfile
	[ :profile :schedule |  |  command | 
		command := (ScAddSchedule profile: profile schedule: schedule).
		[ command undo] 
			should strictly satisfy: [ profile removeSchedule: schedule ]] runScenario! !

TestCase subclass: #TestScAutomaticAllocations
	instanceVariableNames: 'profile account1 account2 pool1 pool2 income'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 14:59'!
newBillEvery: anInterval by: aNumber
	^(profile newSchedule)
		name: 'bill';
		start: (Date tomorrow);
		interval: anInterval;
		count: aNumber;
		transaction: (self newExpense);
		yourself.
! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 15:05'!
newExpense
	^(ScExpense profile: profile)
		sourcePool: pool2;
		sourceAccount: account2;
		amount: 100! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/23/2012 17:31'!
newTransfer
	^(ScTransaction profile: profile)
		sourceAccount: account1;
		account: account2! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/17/2012 20:24'!
setUp
	profile := ScBasicProfile new.
	account1 := profile newAccount 
		name: 'account1';
		openingBalance: 0.
	account2 := profile newAccount
		name: 'account2';
		openingBalance: 0.
	profile 
		addAccount: account1;
		addAccount: account2.
		
	pool1 := profile newPool
		name: 'pool1';
		defaultAccount: account1.
	pool2 := profile newPool
		name: 'pool2';
		defaultAccount: account2.
	profile
		addPool: pool1;
		addPool: pool2.
	income := profile newSchedule
		start: Date tomorrow;
		interval: #week;
		count: 2;
		transaction: ((ScIncome profile: profile)	account: account1; amount: 100).
	profile addSchedule: income.! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/23/2012 17:31'!
testAddToManualTransactions
	income addTransaction: self newTransfer.
	self assert: income manualTransactions size equals: 1! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 13:57'!
testAutomaticAllocationCreatesBothAllocationAndTransfer
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions size equals: 2! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 18:03'!
testAutomaticAllocationDoesntCreateUnnecessaryAllocation
	| bill |
	bill := self newBillEvery: income interval by: income count.
	bill sourcePool: nil.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions size equals: 1! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 18:01'!
testAutomaticAllocationDoesntCreateUnnecessaryTransfer
	| bill |
	bill := self newBillEvery: income interval by: income count.
	bill sourceAccount: account1.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions size equals: 1! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 18:01'!
testAutomaticAllocationHasCorrectDestinationAccount
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	income automaticTransactions second account 
		should be: bill sourceAccount! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 18:01'!
testAutomaticAllocationHasCorrectDestinationPool
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	income automaticTransactions first pool 
		should be: bill sourcePool! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 17:58'!
testAutomaticAllocationHasCorrectSourceAccount
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	income automaticTransactions second sourceAccount should be: income account! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 17:58'!
testAutomaticAllocationHasCorrectSourcePool
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	income automaticTransactions first sourcePool should be: income pool! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 18:00'!
testBillWithSameTimetableIsAllocatedCompletely
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	income automaticTransactions first amount should be: bill amount.! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 15:01'!
testCoveringABillCreatesAnAutomaticTransaction
	| bill |
	bill := self newBillEvery: #week by: 2.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions notEmpty! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 14:27'!
testFirstAutomaticAllocationIsNotTransfer
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	self deny: income automaticTransactions first isTransfer! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 13:56'!
testFirstAutomaticAllocationIsPoolAllocation
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions first isAllocation! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 18:00'!
testFortnightlyBillWeeklyPay
	| bill |
	income interval: #week; count: 1.
	bill := self newBillEvery: #week by: 2.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions first amount equals: (bill amount / 2).! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 18:03'!
testFortnightlyBillWeeklyPayWithInsufficientPay
	| bill |
	income interval: #week; count: 1.
	bill := self newBillEvery: #week by: 2.
	bill amount: 300.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions first amount equals: (bill amount / 2). "Allocate the same amount, even though it's not enough"! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 14:57'!
testIncomeCoveringNoBillsHasNoAutomaticTransactions
	income automaticTransactions size should be: 0! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/23/2012 17:30'!
testManualTransactionsIncludedInAutomaticTransactions
	income addTransaction: self newTransfer.
	self assert: income automaticTransactions size equals: 1! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/23/2012 17:31'!
testManualTransactionsNotIncludedInBillsCovered
	income addTransaction: self newTransfer.
	self assert: income billsCovered size equals: 0! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 17:59'!
testMonthlyBillWeeklyPay
	| bill expected |
	income interval: #week; count: 1.
	bill := self newBillEvery: #month by: 1.
	profile addSchedule: bill.
	bill coveredBy: income.
	expected := ((bill amount / (ScYearly inDays / 12)) * 7) roundTo: (1/100). " (Amount / days in a month - averaged over four years) multiplied by days in a week.  Then round to nearest cent"
	self assert: income automaticTransactions first amount equals: expected.! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/23/2012 17:31'!
testNewScheduleHasNoManualTransactions
	self assert: income manualTransactions size equals: 0! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/23/2012 17:32'!
testRemoveFromManualTransactions
	| t |
	t := self newTransfer.
	income addTransaction: t.
	income removeTransaction: t.
	self assert: income manualTransactions size equals: 0! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 13:57'!
testSecondAutomaticAllocationIsNotAllocation
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	self deny: income automaticTransactions second isAllocation! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 13:56'!
testSecondAutomaticAllocationIsTransfer
	| bill |
	bill := self newBillEvery: income interval by: income count.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions second isTransfer! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/10/2012 17:29'!
testUnallocatedWhenNoBillsCovered
	self assert: income unallocated equals: 100.! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 17:59'!
testUnallocatedWithBillAndManualTransactions
	| bill |
	bill := self newBillEvery: #week by: 2.
	bill amount: 20.
	profile addSchedule: bill.
	bill coveredBy: income.
	income addTransaction: (self newTransfer 
		amount: 5;
		yourself).
	self assert: income unallocated equals: 75! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/10/2012 17:27'!
testUnallocatedWithManualTransaction
	income
		addTransaction: (self newTransfer
			amount: 20;
			yourself).
	self assert: income unallocated equals: 80! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 17:59'!
testUnallocatedWithOneBillCovered
	| bill |
	bill := self newBillEvery: #week by: 2.
	bill amount: 20.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income unallocated equals: 80! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 17:59'!
testWeeklyBillFortnightlyPay
	| bill |
	income interval: #week; count: 2.
	bill := self newBillEvery: #week by: 1.
	bill amount: 20.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions first amount equals: bill amount * 2.! !

!TestScAutomaticAllocations methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 17:59'!
testWeeklyBillFortnightlyPayWithInsufficientPay
	| bill |
	income interval: #week; count: 2.
	bill := self newBillEvery: #week by: 1.
	profile addSchedule: bill.
	bill coveredBy: income.
	self assert: income automaticTransactions first amount equals: bill amount * 2! !

TestCase subclass: #TestScCommands
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScCommands methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:18'!
testScAddAccount
	[ :profile :account | | command |
		[ ( ScAddAccount profile: profile account: account) do]  should strictly satisfy: [
			profile addAccount: account ] ] runScenario! !

!TestScCommands methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 14:02'!
testScAddPool
	[ :profile :pool | 
		[ (ScAddPool profile: profile pool: pool) do]  should strictly satisfy: [
			profile addPool: pool ] ] runScenario! !

!TestScCommands methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 15:48'!
testUndoScAddAccount
	[ :profile :account | | command |
		command := ScAddAccount profile: profile account: account.
		 [command undo ]  should strictly satisfy: [
			profile removeAccount: account ] ] runScenario! !

!TestScCommands methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/22/2012 15:49'!
testUndoScAddPool
	[ :profile :pool | | command |
		command := ScAddPool profile: profile pool: pool.
		[command undo ]  should strictly satisfy: [
			profile removePool: pool ] ] runScenario! !

TestCase subclass: #TestScDeleteSchedule
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core-Commands'!

!TestScDeleteSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/31/2012 10:07'!
testDeleteScheduleRemovesFromProfile
	[ :profile :schedule | [ (ScDeleteSchedule profile: profile schedule: schedule) do ] 
		should strictly satisfy: [ profile removeSchedule: schedule ]] runScenario
! !

!TestScDeleteSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/31/2012 10:06'!
testUndoDeleteScheduleReturnsToProfile
	[ :profile :schedule |  |  command | 
		command := (ScDeleteSchedule profile: profile schedule: schedule).
		[ command undo] 
			should strictly satisfy: [ profile addSchedule: schedule ]] runScenario! !

TestCase subclass: #TestScPool
	instanceVariableNames: 'profile account'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 15:59'!
newPool
	^profile newPool! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:36'!
setUp
	profile := ScBasicProfile new.
	account := profile addAccount: (profile newAccount name: 'account'; yourself).! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/4/2012 21:39'!
testAcceptPendingUpdatesPoolBalance
	| pool |
	pool :=  profile addPool: (self newPool).
	(profile instVarNamed: #pendingTransactions) add: (ScScheduledTransaction schedule: nil transaction: (profile newIncome pool: pool; account: account; amount: 1)).
	(ScAcceptTransactions profile: profile transactions: (profile pendingTransactions)) do.
	self assert: pool balance equals: 1.! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:36'!
testAddingTransactionIncreasesBalance
	| pool |
	pool := profile addPool: self newPool.
	profile addTransaction: (profile newIncome account: account; pool: pool; amount: 10; yourself).
	self assert: pool balance equals: 10.
	! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/7/2012 21:49'!
testDefaultAccountMustExistInProfile
	[self newPool defaultAccount: ScAccount new ] 
		should raise: MbValidationError! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:37'!
testModifyingTransactionChangesBalance
	| pool t |
	pool := profile addPool: self newPool.
	t := profile addTransaction: (profile newIncome account: account; pool: pool; amount: 10; yourself).
	t amount: 15.
	self assert: pool balance equals: 15.
	! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 21:01'!
testPoolIsNotAccount
	self deny: self newPool isAccount! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 21:01'!
testPoolIsPool
	self assert: self newPool isPool! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:56'!
testReallocatingTransactionChangesBalance
	| pool t |
	pool := profile addPool: self newPool.
	t := profile addTransaction: (profile newIncome account: account; pool: pool; amount: 10; yourself).
	t pool: nil.
	self assert: pool balance equals: 0.
	! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:39'!
testRemovingTransactionDecreasesBalance
	| pool t |
	pool := profile addPool: self newPool.
	t := profile addTransaction: (profile newIncome account: account; pool: pool; amount: 10; yourself).
	profile removeTransaction: t.
	self assert: pool balance equals: 0.
	! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:39'!
testStartingBalanceIsZero
	self assert: profile newPool balance equals: 0! !

!TestScPool methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 16:02'!
testTransactionWithPoolSetAppearsinPoolsTransactionList
	| pool t |
	pool := self newPool.
	profile addPool: pool.
	t := profile newTransaction
			pool: pool.
	profile addTransaction: t.
	pool transactions should include: t.! !

TestCase subclass: #TestScPoolNotOverdrawn
	instanceVariableNames: 'profile analyser account zeroBalancePool overdrawnPool positivePool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScPoolNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/25/2012 21:48'!
setUp
	profile := ScBasicProfile new.
	account := profile 
		addAccount: (profile newAccount name: 'ZeroBalance Account'; openingBalance: 0;yourself).
	
	overdrawnPool := profile 
		addPool: (profile newPool name: 'Overdrawn Pool'; defaultAccount: account; yourself).
	zeroBalancePool := profile 
		addPool: (profile newPool name: 'Zero Balance Pool'; defaultAccount: account; yourself).
	positivePool := profile 
		addPool: (profile newPool name: 'Positive Pool'; defaultAccount: account; yourself).

	profile addTransaction: (profile newExpense
		sourceAccount: account;
		sourcePool: overdrawnPool;
		amount: 1).

	profile addTransaction: (profile newIncome
		account: account;
		pool: positivePool;
		amount: 1).
		
	analyser := ScPoolsNotOverdrawn profile: profile.
	analyser modificationAnnouncer: (profile instVarNamed: #announcer).
	analyser notices. "Force a run of the analyser"! !

!TestScPoolNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/25/2012 19:32'!
testAddingExpenseRaisesNotice
	account openingBalance: 10. "Ensure that account doesn't go negative"
	
	profile addTransaction: (profile newExpense
		sourcePool: positivePool;
		sourceAccount: account;
		amount: 2;
		yourself).
	self assert: (analyser notices anySatisfy: [ :n | n pool = positivePool ])! !

!TestScPoolNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 21:18'!
testAddingIncomeRemovesNotice
	profile addTransaction: (profile newIncome
		pool: overdrawnPool;
		account: account;
		amount: 2;
		yourself).
	self deny: (analyser notices anySatisfy: [ :n | n pool = overdrawnPool ])! !

!TestScPoolNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 21:18'!
testModifyingTransactionRaisesNotice
	| t|
	t := profile addTransaction: (
			profile newExpense
			sourcePool: positivePool;
			amount: 1;
			yourself).
	t amount: 2.
	self assert: (analyser notices anySatisfy: [ :n | n pool = positivePool ])! !

!TestScPoolNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 21:15'!
testModifyingTransactionRemovesNotice
	| t |
	t := profile addTransaction: (
			profile newExpense
				sourcePool: positivePool;
				amount: 2;
				yourself).
	t amount: 1.
	self deny: (analyser notices anySatisfy: [ :n | n pool = positivePool ])! !

!TestScPoolNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 19:57'!
testOnlyOneAccountRaisesNotice
	self assert: analyser notices size equals: 1! !

!TestScPoolNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 20:52'!
testOverdrawnPoolShouldRaiseNotice
	self assert: (analyser notices anySatisfy: [ :n | n pool = overdrawnPool ])! !

!TestScPoolNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 21:08'!
testPoolWithNearZeroAmountIsNotOverdrawn
	profile addTransaction: (profile newExpense 
		amount: ((Fraction numerator: 3 denominator: 1759218604441600) asScaledDecimal: 2);
		sourcePool: zeroBalancePool;
		sourceAccount: account).
	self deny: (analyser notices anySatisfy: [ :n | n pool = zeroBalancePool])! !

!TestScPoolNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 21:09'!
testPositiveBalancePoolShouldntRaiseNotice
	self deny: (analyser notices anySatisfy: [ :n | n pool = positivePool ])! !

!TestScPoolNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 21:17'!
testRemovingExpenseRemovesNotice
	| t | 
	t := (profile newExpense
		sourcePool: positivePool;
		sourceAccount: account;
		amount: 2;
		yourself).
	profile addTransaction: t.
	profile removeTransaction: t.
	self deny: (analyser notices anySatisfy: [ :n | n pool = positivePool ])! !

!TestScPoolNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 21:17'!
testRemovingIncomeRaisesNotice
	| t | 
	t := (profile newIncome
		pool: overdrawnPool;
		account: account;		
		amount: 2;
		yourself).
	profile addTransaction: t.
	profile removeTransaction: t.
	self assert: (analyser notices anySatisfy: [ :n | n pool = overdrawnPool ])! !

!TestScPoolNotOverdrawn methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 21:08'!
testZeroBalancePoolShouldntRaiseNotice
	self deny: (analyser notices anySatisfy: [ :n | n pool = zeroBalancePool ])! !

TestCase subclass: #TestScProfile
	instanceVariableNames: 'profile'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/17/2012 20:24'!
setUp
	profile := ScBasicProfile new.! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:30'!
testAddAccount
	[ :account | 
		[ profile addAccount: account ] should lenient satisfy:  [ 
				account openingBalance willReturn: 0.
				account modificationAnnouncer: Any ]]
					runScenario.
	self assert: profile accounts size equals: 1

! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 20:00'!
testAddAccountReturnsAccount
	| account |
	account := profile newAccount.
	self assert:  (profile addAccount: account) equals: account.! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2012 21:19'!
testAddAccountWithSameNameFails
	profile addAccount: (ScAccount new name: 'foo'; yourself).
	self should: [ profile addAccount: (ScAccount new name: 'foo'; yourself)] raise: MbValidationError! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/11/2012 21:33'!
testAddPool
	[ :pool | 
		[ profile addPool: pool ]  should lenient satisfy:  [ 
				pool modificationAnnouncer: Any ]]
					runScenario.
	self assert: profile pools size equals: 1! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 20:04'!
testAddPoolReturnsPool
	| pool |
	pool := profile newPool.
	self assert:  (profile addPool: pool) equals: pool.! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/18/2012 21:19'!
testAddPoolWithSameNameFails
	profile addPool: (ScPool new name: 'foo'; yourself).
	self should: [ profile addPool: (ScPool new name: 'foo'; yourself)] raise: MbValidationError! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/11/2012 21:34'!
testAddScedule
	[ :schedule | 
		[profile addSchedule: schedule]  should lenient satisfy:  [ 
				schedule modificationAnnouncer: Any ]]
					runScenario.
	self assert: profile schedules size equals: 1! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 20:05'!
testAddScheduleReturnsSchedule
	| account |
	account := profile newSchedule.
	self assert:  (profile addSchedule: account) equals: account.! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 16:58'!
testAddScheduleWithSameNameFails
	profile addSchedule: (ScSchedule new name: 'foo'; yourself).
	self should: [ profile addSchedule: (ScSchedule new name: 'foo'; yourself)] raise: MbValidationError! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/11/2012 21:37'!
testExpectedTransactionsBy
	| result |
	[ :schedule1 :schedule2 | 
		[profile addSchedule: schedule1.
		profile addSchedule: schedule2.
		profile expectedTransactionsBy: Date tomorrow ] should lenient
			satisfy: [ 
				schedule1 modificationAnnouncer: Any.
				schedule1 name willReturn: 's1'.
				schedule2 modificationAnnouncer: Any.
				schedule2 name willReturn: 's2'.
				(schedule1 transactionsBetween: Date today and: Date tomorrow) willReturn: #().
				(schedule2 transactionsBetween: Date today and: Date tomorrow) willReturn: #() ] ] runScenario! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/29/2012 12:41'!
testExpectedTransactionsByIncludesPending
	| transaction s |
	s := profile addSchedule: (profile newSchedule).
	transaction :=  profile newExpense. 
	(profile instVarNamed: #pendingTransactions) add: (ScScheduledTransaction schedule: s transaction: transaction).
	(profile expectedTransactionsBy: Date tomorrow)  should include: transaction.! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/11/2012 21:37'!
testExpectedTransactionsByReturnsCorrectTransactions
	| result |
	[ :schedule1 :schedule2 | 
		[profile addSchedule: schedule1.
		profile addSchedule: schedule2.
		self assert: ((profile expectedTransactionsBy: Date tomorrow) hasEqualElements: #(1 2 3 a b c)) ] 
			should lenient satisfy: [
				schedule1 modificationAnnouncer: Any.				
				schedule1 name willReturn: 's1'.
				schedule2 modificationAnnouncer: Any.
				schedule2 name willReturn: 's2'.
				(schedule1 transactionsBetween: Any and: Any) willReturn: #(1 2 3).
				(schedule2 transactionsBetween: Any and: Any) willReturn: #(a b c) ]] runScenario.
	! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 08:41'!
testLastCheckpointIsTodayForNewInstances
	self assert: profile checkpointDate equals: Date today! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/4/2012 17:02'!
testNewSchedule
	self assert: (profile newSchedule instVarNamed: #profile) equals: profile! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 08:43'!
testPendingIsEmptyForNewInstance
	self assert: profile pendingTransactions isEmpty! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:30'!
testRemoveAccount
	[ :account | 
		[profile addAccount: account.
		profile removeAccount: account] should lenient satisfy: [
			account openingBalance willReturn: 0.
			account modificationAnnouncer: Any.
			account modificationAnnouncer: nil] ] runScenario.
	self assert: profile accounts isEmpty

! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 20:03'!
testRemoveAccountReturnsAccount
	| account |
	account := profile newAccount.
	profile addAccount: account.
	self assert:  (profile removeAccount: account) equals: account.! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/11/2012 21:36'!
testRemovePool
	[:pool |
		[profile addPool: pool.
		profile removePool: pool] should lenient satisfy: [
			pool modificationAnnouncer: Any.
			pool modificationAnnouncer: nil] ] runScenario.
	self assert: profile pools isEmpty

! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 20:03'!
testRemovePoolReturnsPool
	| pool |
	pool := profile newPool.
	profile addPool: pool.
	self assert:  (profile removePool: pool) equals: pool.! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/11/2012 21:36'!
testRemoveSchedule
	[ :schedule | 
		[profile addSchedule: schedule.
		profile removeSchedule: schedule ] should lenient satisfy: [
			schedule modificationAnnouncer: Any.
			schedule modificationAnnouncer: nil] ] runScenario.
	self assert: profile schedules isEmpty

! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/13/2012 20:03'!
testRemoveScheduleReturnsSchedule
	| account |
	account := profile newSchedule.
	profile addSchedule: account.
	self assert:  (profile removeSchedule: account) equals: account.! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/29/2012 12:56'!
testUpdatePendingOnlyAddsPendingTransactionsOnce
	profile addSchedule: (profile newSchedule
			start: Date yesterday;
			interval: #month;
			count: 1;
			transaction: (ScIncome new)).
	profile instVarNamed: #checkpoint put: (Date today subtractDays: 7).
	profile updatePending.
	profile updatePending.
	self assert: profile pendingTransactions size equals: 1! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 08:58'!
testUpdatePendingPopulatesPendingTransactions
	profile addSchedule: (profile newSchedule
			start: Date yesterday;
			interval: #month;
			count: 1;
			transaction: (ScIncome new)).
	profile instVarNamed: #checkpoint put: (Date today subtractDays: 7).
	profile updatePending.
	self assert: profile pendingTransactions size equals: 1! !

!TestScProfile methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/10/2012 08:42'!
testUpdatePendingUpdatesCheckpointDate
	profile instVarNamed: #checkpoint put: Date yesterday.
	profile updatePending.
	self assert: profile checkpointDate equals: Date today.! !

TestCase subclass: #TestScRecordTransaction
	instanceVariableNames: 'profile account pool transaction'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core-Commands'!

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/17/2012 20:24'!
setUp
	profile := ScBasicProfile new.
	account :=  profile newAccount.
	pool := profile newPool.
	profile addAccount: account.
	profile addPool: pool.
	transaction := profile newTransaction
		account: account;
		pool: pool;
		amount: 12.34;
		yourself! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:52'!
testRecordTransactionAddsToAccount
	(ScRecordTransaction profile: profile transaction: transaction) do.
	account transactions should include: transaction.! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:52'!
testRecordTransactionAddsToPool
	(ScRecordTransaction profile: profile transaction: transaction) do.
	pool transactions should include: transaction.! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:40'!
testRecordTransactionAddsToProfile
	[ :p | [ (ScRecordTransaction profile: p transaction: transaction) do ] 
		should strictly satisfy: [ p addTransaction: transaction ]] runScenario
! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:55'!
testRecordTransactionWithNoPoolSucceeds
	transaction pool: nil.
	(ScRecordTransaction profile: profile transaction: transaction) do.
! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:53'!
testUndoRecordTransactionRemovesFromAccount
	(ScRecordTransaction profile: profile transaction: transaction) do; undo.
	account transactions shouldnt include: transaction.! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/1/2012 20:53'!
testUndoRecordTransactionRemovesFromPool
	(ScRecordTransaction profile: profile transaction: transaction) do; undo.
	pool transactions shouldnt include: transaction.! !

!TestScRecordTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/14/2012 16:09'!
testUndoRecordTransactionRemovesFromProfile
	[ :p |  |  command | 
		command := (ScRecordTransaction profile: p transaction: transaction).
		[ command undo] 
			should strictly satisfy: [ p removeTransaction: transaction ]] runScenario! !

TestCase subclass: #TestScRemoveManualTransaction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core-Commands'!

!TestScRemoveManualTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/24/2012 18:14'!
testAddRemoveTransactionsRemovesFromSchedule
	[ :schedule :transaction | [ (ScRemoveManualTransaction new schedule: schedule; transaction: transaction) do ] 
		should strictly satisfy: [ schedule removeTransaction: transaction ]] runScenario
! !

!TestScRemoveManualTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/24/2012 18:13'!
testUndoRemoveTransactionReturnsToSchedule
	[ :schedule :transaction |  |  command | 
		command := (ScRemoveManualTransaction new schedule: schedule; transaction: transaction).
		[ command undo] 
			should strictly satisfy: [ schedule addTransaction: transaction ]] runScenario! !

TestCase subclass: #TestScSchedule
	instanceVariableNames: 'profile account1 account2 pool1 pool2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:51'!
newAllocation
	^(ScTransaction profile: profile)
		pool: pool1;
		account: account1;
		sourceAccount: account1! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:31'!
newExpense
	^ScExpense profile: profile! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:31'!
newIncome
	^ScIncome profile: profile! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:41'!
newTransfer
	^(ScTransaction profile: profile)
		sourceAccount: account1;
		account: account2! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/17/2012 20:24'!
setUp
	profile := ScBasicProfile new.
	account1 := profile newAccount 
		name: 'account1';
		openingBalance: 0.
	account2 := profile newAccount
		name: 'account2';
		openingBalance: 0.
	profile 
		addAccount: account1;
		addAccount: account2.
		
	pool1 := profile newPool
		name: 'pool1';
		defaultAccount: account1.
	pool2 := profile newPool
		name: 'pool2';
		defaultAccount: account2.
	profile
		addPool: pool1;
		addPool: pool2.! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:30'!
testAnnually
	| schedule transactions |
	schedule := (profile newSchedule)
		start: (Date year: 2012 month: 1 day: 14);
		interval: #year;
		count: #1;
		transaction: (self newIncome).
	self assert: (schedule nextAfter: (Date year: 2012 month: 5 day: 6)) equals: (Date year: 2013 month: 1 day: 14)! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:31'!
testBiannually
	| schedule transactions |
	schedule := (profile newSchedule)
		start: (Date year: 2012 month: 1 day: 14);
		interval: #year;
		count: #2;
		transaction: (self newIncome).
	self assert: (schedule nextAfter: (Date year: 2012 month: 5 day: 6)) equals: (Date year: 2014 month: 1 day: 14)! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 14:35'!
testBillCanBeCoveredByIncome
	| s1 s2 |
	s1 := profile newSchedule
		name: 'bill';
		transaction: self newExpense.
	profile addSchedule: s1.
	s2 := profile newSchedule
		name: 'income';
		transaction: self newIncome.
	profile addSchedule: s2.
	[ s1 coveredBy: s2 ] shouldnt raise: MbValidationError! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 14:35'!
testBillCantBeCoveredByAllocation
	| s1 s2 |
	s1 := (profile newSchedule)
		name: 'bill';
		transaction: self newExpense.
	profile addSchedule: s1.
	s2 := (profile newSchedule)
		name: 'bill2';
		transaction: self newExpense.
	profile addSchedule: s2.
	[ s1 coveredBy: s2 ] should raise: MbValidationError! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 14:35'!
testBillCantBeCoveredByOtherBill
	| s1 s2 |
	s1 := profile newSchedule
		name: 'bill';
		transaction: self newExpense.
	profile addSchedule: s1.
	s2 := profile newSchedule
		name: 'bill2';
		transaction: self newExpense.
	profile addSchedule: s2.
	[ s1 coveredBy: s2 ] should raise: MbValidationError! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 14:38'!
testBillsCovered
	| s1 s2 |
	s1 := profile newSchedule
		name: 'bill';
		transaction: self newExpense.
	profile addSchedule: s1.
	s2 := profile newSchedule
		name: 'income';
		transaction: self newIncome.
	profile addSchedule: s2.
	s1 coveredBy: s2.
	s2 billsCovered should include: s1! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:33'!
testDaily
	| schedule transactions |
	schedule := (profile newSchedule)
		start: (Date year: 2012 month: 1 day: 14);
		interval: #day;
		count: #1;
		transaction: (self newIncome).
	self assert: (schedule nextAfter: (Date year: 2012 month: 5 day: 6)) equals: (Date year: 2012 month: 5 day: 7)! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:33'!
testFortnightly
	| schedule transactions |
	schedule := (profile newSchedule)
		start: (Date year: 2012 month: 1 day: 14);
		interval: #week;
		count: #2;
		transaction: (self newIncome).
	self assert: (schedule nextAfter: (Date year: 2012 month: 5 day: 6)) equals: (Date year: 2012 month: 5 day: 19)! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/12/2012 13:01'!
testIncomeCantBeCovered
	| s1 s2  |
	s1 := (ScSchedule profile: nil)
		transaction: (self newIncome).
	s2 := (ScSchedule profile: nil).
	[ s1 coveredBy: s2 ] should raise: MbValidationError! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:40'!
testIsAllocation
	| schedule transactions |
	schedule := (profile newSchedule)
		transaction: (self newAllocation).
	self assert: schedule isAllocation! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:40'!
testIsExpense
	| schedule transactions |
	schedule := (profile newSchedule)
		transaction: (self newExpense).
	self assert: schedule isExpense! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:40'!
testIsIncome
	| schedule transactions |
	schedule := (profile newSchedule)
		transaction: (self newIncome).
	self assert: schedule isIncome! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:41'!
testIsTransfer
	| schedule transactions |
	schedule := (profile newSchedule)
		transaction: (self newTransfer).
	self assert: schedule isTransfer! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:34'!
testMonthly
	| schedule transactions |
	schedule := (profile newSchedule)
		start: (Date year: 2012 month: 1 day: 14);
		interval: #month;
		count: #1;
		transaction: (self newIncome).
	self assert: (schedule nextAfter: (Date year: 2012 month: 5 day: 6)) equals: (Date year: 2012 month: 5 day: 14)! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 14:40'!
testNoBillsCovered
	| s1 |
	s1 := profile newSchedule
		name: 'income';
		transaction: self newIncome.
	profile addSchedule: s1.
	s1 billsCovered isEmpty should be: true.! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 7/29/2012 12:38'!
testPendingTransactions
	| t s |
	t := profile newExpense.
	s := profile newSchedule.
	(profile instVarNamed: #pendingTransactions) add: (ScScheduledTransaction schedule: s transaction: t).
	s pendingTransactions should include: t
	! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:34'!
testQuarterly
	| schedule transactions |
	schedule := (profile newSchedule)
		start: (Date year: 2012 month: 1 day: 14);
		interval: #month;
		count: #3;
		transaction: (self newIncome).
	self assert: (schedule nextAfter: (Date year: 2012 month: 5 day: 6)) equals: (Date year: 2012 month: 7 day: 14)! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:34'!
testTransactionsBetween
	| schedule transactions |
	schedule := (profile newSchedule)
		start: (Date year: 2012 month: 1 day: 14);
		interval: #month;
		count: #1;
		transaction: (self newIncome).
		
	transactions := schedule transactionsBetween: (Date year: 2012 month: 2 day: 1) and: (Date year: 2012 month: 2 day: 20).
	self assert: transactions size equals: 1.
	self assert: transactions first date equals: (Date year: 2012 month: 2 day: 14)! !

!TestScSchedule methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:34'!
testWeekly
	| schedule transactions |
	schedule := (profile newSchedule)
		start: (Date year: 2012 month: 1 day: 14);
		interval: #week;
		count: #1;
		transaction: (self newIncome).
	self assert: (schedule nextAfter: (Date year: 2012 month: 5 day: 6)) equals: (Date year: 2012 month: 5 day: 12)! !

TestCase subclass: #TestScTimetable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScTimetable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:46'!
testDailyToWeeklyRatio
	self assert: (ScDaily new ratioFor: ScWeekly new) equals: 7! !

!TestScTimetable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/27/2012 14:20'!
testFortnightlyToMonthlyRatio
	self assert: ((ScWeekly every: 2) ratioFor: (ScMonthly new)) equals:  (365/168) "(487/224)"! !

!TestScTimetable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/27/2012 14:20'!
testMonthlyToFortnightlyRatio
	self assert: (ScMonthly new ratioFor: (ScWeekly every: 2)) equals: (168/365) "(224/487)"! !

!TestScTimetable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/27/2012 14:30'!
testMonthlyToWeeklyRatio
	self assert: (ScMonthly new ratioFor: (ScWeekly new)) equals: (84/365)"(112/487)"! !

!TestScTimetable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:47'!
testWeeklyToFortnightlyRatio
	self assert: (ScWeekly new ratioFor: (ScWeekly every: 2)) equals: 2! !

!TestScTimetable methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/27/2012 14:30'!
testWeeklyToMonthlyRatio
	self assert: (ScWeekly new ratioFor: (ScMonthly new)) equals: (365/84)"(487/112)"! !

TestCase subclass: #TestScTransaction
	instanceVariableNames: 'profile a1 p1 p2 a2'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:35'!
newTransaction
	^profile newTransaction! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/17/2012 20:24'!
setUp
	profile := ScBasicProfile new.
	a1 := (ScAccount new name: 'account'; yourself).
	a2 := (ScAccount new name: 'account2'; yourself).
	p1 := (ScPool new name: 'pool'; yourself).
	p2 := (ScPool new name: 'pool2'; yourself).
	profile addAccount: a1.
	profile addAccount: a2.
	profile addPool: p1.
	profile addPool: p2.! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 21:42'!
testChangingBalanceSendsTransactionModifiedAnnouncement
	[ :a | | t | 
	t := self newTransaction.
		t modificationAnnouncer: a.
		[ t amount: 10] should lenient satisfy: [ a announce: (Instance of: ScTransactionBalanceModified)] ] runScenario ! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/11/2012 18:34'!
testExpenseIsNotTransfer
	self deny: profile newExpense isTransfer.! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/11/2012 18:33'!
testIncomeIsNotTransfer
	self deny: profile newIncome isTransfer.! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionAccountMustExistInProfile
	[self newTransaction account: ScAccount new ] 
		should raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionAccountMustExistInProfileSuccess
	[self newTransaction account: profile accounts first ] 
		should not raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionCanHaveNoPool
	[ self newTransaction pool: nil ] 
		should not raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionMustHaveAccount
	[ self newTransaction account: nil ] 
		should raise: MbRequiredFieldError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:30'!
testTransactionPoolMustExistInProfile
	[ self newTransaction pool: ScPool new ]  
		should raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 1/30/2012 18:23'!
testTransactionPoolMustExistInProfileSuccess
	[ self newTransaction pool: profile pools first ] 
		should not raise: MbValidationError! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:57'!
testTransactionWithBothSourceAndDestinationAccountIsNotExpense
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a2.
	t isExpense should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:56'!
testTransactionWithBothSourceAndDestinationAccountIsNotIncome
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a2.
	t isIncome should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:54'!
testTransactionWithBothSourceAndDestinationAccountIsTransfer
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a2.
	t isTransfer should be: true! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 14:06'!
testTransactionWithDifferentSourceAndDestinationAccountAndPoolIsAllocation
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a2.
	t pool: p1.
	t sourcePool: p2.
	t isAllocation should be: true! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 14:06'!
testTransactionWithDifferentSourceAndDestinationAccountAndPoolIsTransfer
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a2.
	t pool: p1.
	t sourcePool: p2.
	t isAllocation should be: true! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 14:05'!
testTransactionWithDifferentSourceAndDestinationPoolIsAllocation
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a1.
	t pool: p1.
	t sourcePool: p2.
	t isAllocation should be: true! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:55'!
testTransactionWithOnlyDestinationAccountIsIncome
	| t| 
	t := self newTransaction.
	t account: a1.
	t isIncome should be: true.! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 13:47'!
testTransactionWithOnlyDestinationAccountIsNotExpense
	| t| 
	t := self newTransaction.
	t account: a1.
	t isExpense should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:55'!
testTransactionWithOnlyDestinationAccountIsNotTransfer
	| t| 
	t := self newTransaction.
	t account: a1.
	t isTransfer should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 14:37'!
testTransactionWithOnlyDestinationPoolIsAllocation
	| t| 
	t := self newTransaction.
	t pool: p1.
	self assert: t isAllocation ! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:56'!
testTransactionWithOnlySourceAccountIsExpense
	| t| 
	t := self newTransaction.
	t sourceAccount: a1.
	t isExpense should be: true! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:56'!
testTransactionWithOnlySourceAccountIsNotIncome
	| t| 
	t := self newTransaction.
	t sourceAccount: a1.
	t isIncome should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 13:55'!
testTransactionWithOnlySourceAccountIsNotTransfer
	| t| 
	t := self newTransaction.
	t sourceAccount: a1.
	t isTransfer should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 14:55'!
testTransactionWithOnlySourcePoolIsAllocation
	| t| 
	t := self newTransaction.
	t sourcePool: p1.
	t account: a1.
	t sourceAccount: a1.	
	t isAllocation should be: true.! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/25/2012 14:04'!
testTransactionWithSameSourceAndDestinationAccountIsNotTransfer
	| t| 
	t := self newTransaction.
	t account: a1.
	t sourceAccount: a1.
	t pool: p1.
	t isTransfer should be: false! !

!TestScTransaction methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/18/2012 15:01'!
testTransactionWithSameSourceAndDestinationPoolIsNotAllocation
	| t| 
	t := self newTransaction.
	t pool: p1.
	t sourcePool: p1.
	self deny: t isAllocation! !

TestCase subclass: #TestScUnallocated
	instanceVariableNames: 'profile unallocated account pool'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Core'!

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:46'!
newExpense
	^profile newExpense
		sourceAccount: account;
		amount: 1;
		yourself! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:46'!
newIncome
	^profile newIncome
		account: account;
		amount: 1;		
		yourself! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:46'!
newTransaction
	^profile newTransaction
		sourceAccount: account;
		account: account;
		amount: 1;
		yourself! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 21:22'!
setUp
	profile := ScBasicProfile new.
	account := (profile newAccount name: 'account'; yourself).
	pool := (profile newPool name: 'pool'; yourself).
	profile addAccount: account.
	profile addPool: pool.
	unallocated := profile unallocated.! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:10'!
testAccumulateExpenseWithNoSourcePoolIsNegative
	| t |
	t := self newExpense.
	self assert: (unallocated accumulate: t) equals: -1! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:46'!
testAccumulateExpenseWithSourcePoolIsZero
	| t |
	t := self newExpense
			sourcePool: pool.
	self assert: (unallocated accumulate: t) equals: 0! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:10'!
testAccumulateIncomeWithNoPoolIsPositive
	| t |
	t := self newIncome.
	self assert: (unallocated accumulate: t) equals: 1! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:46'!
testAccumulateIncomeWithPoolIsZero
	| t |
	t := self newIncome
			pool: pool.
	self assert: (unallocated accumulate: t) equals: 0! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:46'!
testAccumulateTransactionWithBothPoolsIsZero
	| t |
	t := self newTransaction
		sourcePool: pool;
		pool: pool.
	self assert: (unallocated accumulate: t) equals: 0! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:46'!
testAccumulateTransactionWithNoPoolIsPositive
	| t |
	t := self newTransaction
		sourcePool: pool.
	self assert: (unallocated accumulate: t) equals: 1! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 17:09'!
testAccumulateTransactionWithNoPoolsAtAllIsZero
	| t |
	t := self newTransaction.
	self assert: (unallocated accumulate: t) equals: 0! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:46'!
testAccumulateTransactionWithNoSourcePoolIsNegative
	| t |
	t := self newTransaction
		pool: pool.
	self assert: (unallocated accumulate: t) equals: -1! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:48'!
testAddingAllocatedTransactionDoesntChangeBalance
	profile addTransaction: (self newIncome pool: pool; yourself).
	self assert: unallocated balance equals: 0.! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:48'!
testAddingUnallocatedTransactionIncreasesBalance
	profile addTransaction: self newIncome.
	self assert: unallocated balance equals: 1.! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 21:38'!
testAllocatedExpenseIsNotIncoming
	self deny: (unallocated isIncoming: (self newExpense sourcePool: pool; yourself)).! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 21:38'!
testAllocatedExpenseIsNotOutgoing
	self deny: (unallocated isOutgoing: (self newExpense sourcePool: pool; yourself)).! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 21:38'!
testAllocatedIncomeIsNotIncoming
	self deny: (unallocated isIncoming: (self newIncome pool: pool; yourself)).! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 21:39'!
testAllocatedIncomeIsNotOutgoing
	self deny: (unallocated isOutgoing: (self newIncome pool: pool; yourself)).! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:51'!
testAllocatingTransactionChangesBalance
	| t |
	t := profile addTransaction: self newIncome.
	t pool: pool.
	self assert: unallocated balance equals: 0.! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 21:42'!
testAllocationIsNotIncoming
	self deny: (unallocated isIncoming: (self newTransaction 
		pool: pool;
		yourself)).! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 21:41'!
testAllocationIsOutgoing
	self assert: (unallocated isOutgoing: (self newTransaction 
		pool: pool;
		yourself)).! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 21:22'!
testChangingOpeningBalanceUpdatesBalance
	account openingBalance: 10.
	self assert: unallocated balance equals: 10! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:49'!
testChangingOpeningBalanceUpdatesOpeningBalance
	account openingBalance: 10.
	self assert: unallocated openingBalance equals: 10! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 21:41'!
testDeallocationIsIncoming
	self assert: (unallocated isIncoming: (self newTransaction 
		sourcePool: pool;
		yourself)).! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 21:42'!
testDeallocationIsNotOutgoing
	self deny: (unallocated isOutgoing: (self newTransaction 
		sourcePool: pool;
		yourself)).! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:50'!
testModifyingTransactionBalanceChangesBalance
	| t |
	t := profile addTransaction: self newIncome.
	t amount: 15.
	self assert: unallocated balance equals: 15.! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 21:43'!
testReallocationIsNotIncoming
	| pool2| 
	pool2 := profile addPool: (profile newPool name: 'p2'; yourself).
	self deny: (unallocated isIncoming: (self newTransaction 
		pool: pool;
		sourcePool: pool2;
		yourself)).! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 21:44'!
testReallocationIsNotOutgoing
	| pool2| 
	pool2 := profile addPool: (profile newPool name: 'p2'; yourself).
	self deny: (unallocated isOutgoing: (self newTransaction 
		pool: pool;
		sourcePool: pool2;
		yourself)).! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:50'!
testRemovingTransactionDecreasesBalance
	| t |
	t := profile addTransaction: self newIncome.
	profile removeTransaction: t.
	self assert: unallocated balance equals: 0.! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:47'!
testStartingBalanceIsZero
	self assert: unallocated balance equals: 0! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:47'!
testStartingOpeningBalanceIsZero
	self assert: unallocated openingBalance equals: 0! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 21:40'!
testTransferIsNotIncoming
	| account2 |
	account2 := profile addAccount: (profile newAccount name: 'a2'; yourself).
	self deny: (unallocated isIncoming: (self newTransaction 
		sourceAccount: account; 
		account: account2;
		yourself)).! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 21:40'!
testTransferIsNotOutgoing
	| account2 |
	account2 := profile addAccount: (profile newAccount name: 'a2'; yourself).
	self deny: (unallocated isOutgoing: (self newTransaction 
		sourceAccount: account; 
		account: account2;
		yourself)).! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:46'!
testUnallocatedDoesntOwnExpenseWithSourcePool
	| t |
	t := self newExpense
			sourcePool: pool.
	self deny: (unallocated ownsTransaction: t)! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:46'!
testUnallocatedDoesntOwnIncomeWithPool
	| t |
	t := self newIncome
			pool: pool.
	self deny: (unallocated ownsTransaction: t)! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:46'!
testUnallocatedDoesntOwnTransactionWithBothPools
	| t |
	t := self newTransaction
		sourcePool: pool;
		pool: pool.
	self deny: (unallocated ownsTransaction: t)! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 16:40'!
testUnallocatedDoesntOwnTransactionWithNoPoolsAtAll
	| t |
	t := self newTransaction.
	self deny: (unallocated ownsTransaction: t)! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 21:37'!
testUnallocatedExpenseIsNotIncoming
	self deny: (unallocated isIncoming: self newExpense).! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 21:36'!
testUnallocatedExpenseIsOutgoing
	self assert: (unallocated isOutgoing: self newExpense).! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 21:36'!
testUnallocatedIncomeIsIncoming
	self assert: (unallocated isIncoming: self newIncome).! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/20/2012 21:37'!
testUnallocatedIncomeIsNotOutgoing
	self deny: (unallocated isOutgoing: self newIncome).! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 16:39'!
testUnallocatedOwnsExpenseWithNoSourcePool
	| t |
	t := self newExpense.
	self assert: (unallocated ownsTransaction: t)! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 3/17/2012 16:39'!
testUnallocatedOwnsIncomeWithNoPool
	| t |
	t := self newIncome.
	self assert: (unallocated ownsTransaction: t)! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:46'!
testUnallocatedOwnsTransactionWithNoPool
	| t |
	t := self newTransaction
		sourcePool: pool.
	self assert: (unallocated ownsTransaction: t)! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:46'!
testUnallocatedOwnsTransactionWithNoSourcePool
	| t |
	t := self newTransaction
		pool: pool.
	self assert: (unallocated ownsTransaction: t)! !

!TestScUnallocated methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/18/2012 20:51'!
testUnallocatingTransactionChangesBalance
	| t |
	t := profile addTransaction: (self newIncome pool: pool; yourself).
	t pool: nil.
	self assert: unallocated balance equals: 1.! !

TestCase subclass: #TestScwScheduleTable
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Web'!

STTestCase subclass: #TestScwComponent
	instanceVariableNames: 'announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Web'!

!TestScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 18:43'!
invokeCallback: aSingleArgumentBlock
	self component block: aSingleArgumentBlock.
	(self lastResponse anchorWithLabel: 'Go') click.! !

!TestScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 6/11/2012 13:53'!
setUp
	super setUp.
	self newApplicationWithRootClass: TestingScwRoot.
	self establishSession.
	announcer := Announcer new.
	self component announcer:  announcer.
	announcer on: ScwModalAnnouncement do: [ :a | | result | a result: (self component call: a component) ]! !

!TestScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 18:44'!
testCallModalOpensDialog
	self invokeCallback: [ : c | c callModal: WAFormDialog new].
	self assert: (self lastResponse 
		buttonWithValue: 'Ok') notNil! !

!TestScwComponent methodsFor: 'as yet unclassified' stamp: 'StuartHerring 8/12/2012 13:02'!
testCallModalReturnsValueOnAnswer
	| value |
	value := nil.
	self invokeCallback: [ : c | value := c callModal: WAYesOrNoDialog new ].
	(self lastResponse buttonWithValue: 'Yes') click.
	self assert: value ! !

WAComponent subclass: #ModalDialog
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Web'!

!ModalDialog methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 19:53'!
renderContentOn: html
	html paragraph: 'Hello!!'.
	html anchor callback: [self answer: 42]; with: 'Close'! !

WAComponent subclass: #ModalTest
	instanceVariableNames: 'answer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Web'!

!ModalTest class methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 19:52'!
canBeRoot
	^true! !

!ModalTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 19:55'!
callModal: aDialog
	^self call: aDialog! !

!ModalTest methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/26/2012 20:30'!
renderContentOn: html
	html container: [
		html paragraph: [
		html anchor callback: [answer := self callModal: ModalDialog new]; with: 'Open Dialog'].
		html paragraph: [
			html anchor 
				attributeAt: 'data-toggle' put: 'modal'; 
				attributeAt: 'data-backdrop' put: 'false';
				url: '#xxx'; with: 'Open Modal'.].

		answer ifNotNil: [html heading level: 1; with: answer].
		
	html div class: 'modal'; class: 'hide'; id: 'xxx'; with: 'Foo'].
	html script: ((html jQuery id: 'xxx') call: 'on' with: 'show' with: ((html jQuery id: 'xxx') load html: [ :h | h render: ModalDialog new ] ) asFunction)! !

ScwComponent subclass: #TestingScwRoot
	instanceVariableNames: 'block announcer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Smallchange-Test-Web'!

!TestingScwRoot methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 18:53'!
announcer
	^announcer! !

!TestingScwRoot methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 18:53'!
announcer: anAnnouncer
	announcer := anAnnouncer.! !

!TestingScwRoot methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 18:39'!
block: aBlock
	block := aBlock! !

!TestingScwRoot methodsFor: 'as yet unclassified' stamp: 'StuartHerring 2/12/2012 18:42'!
renderContentOn: html
	html anchor callback: [ block value: self ]; with: 'Go'! !
